﻿using System;
using System.Collections.Generic;
using System.Text;

namespace BitMaskTest
{
    // [Flags]
    // public enum ButtonMask
    // {
    // 	None = 0x00,
    // 	Remove = 0x01,
    // 	LevelUp = 0x02,
    // 	Change = 0x04,
    // 	Reset = 0x08,
    // 	Cancel = 0x10,
    // }

    [Flags]
    public enum ButtonMask
    {
        None = 0,
        Remove = 1 << 0,
        LevelUp = 1 << 1,
        Change = 1 << 2,
        Reset = 1 << 3,
        Cancel = 1 << 4,

        All = int.MaxValue
    }

    class PopupButtonMask
    {
        public ButtonMask Mask { get; set; } = ButtonMask.None;

        public List<ButtonMask> GetButtons()
        {
            List<ButtonMask> buttons = new List<ButtonMask>();
            foreach (ButtonMask flag in Enum.GetValues(typeof(ButtonMask)))
            {
                if (checkMask(flag))
                    buttons.Add(flag);
            }

            if (buttons == null || buttons.Count < 1)
                return null;

            return buttons;
        }

        public bool checkMask(ButtonMask compareTarget)
        {
            int flags = (int)this.Mask;
            int flag = (int)compareTarget;

            return (flags & flag) != 0;
        }
    }
}
